'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _index = require('next/dist/lib/router/index.js');

var _index2 = _interopRequireDefault(_index);

var _auth0Lock = require('auth0-lock');

var _auth0Lock2 = _interopRequireDefault(_auth0Lock);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// Use as simple link wrapper
// <Lock redirect="/here">A link</Lock>
// Custom usage
// <Lock redirect="/here" children={({show, hide})=>(<a onClick={show} href="/login">My Login</a>)} />
// <Lock ready={(lock)=>{lock.show()}} />

var Lock = function (_React$Component) {
  (0, _inherits3.default)(Lock, _React$Component);

  function Lock(props) {
    (0, _classCallCheck3.default)(this, Lock);

    var _this = (0, _possibleConstructorReturn3.default)(this, (Lock.__proto__ || (0, _getPrototypeOf2.default)(Lock)).call(this, props));

    _this.onClick = function (e) {
      e.preventDefault();
      try {
        window.localStorage.setItem('auth0Redirect', _this.props.redirect);
      } catch (e) {// local storage is disabled just ignore
      }

      _this.lock && _this.lock.show();
    };

    return _this;
  }

  (0, _createClass3.default)(Lock, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      var _this2 = this;

      // Cross-browser window.origin
      var origin = window.location.protocol + "//" + window.location.hostname + (window.location.port ? ':' + window.location.port : '');

      // Configure Auth0 instance
      this.lock = this.lock || new _auth0Lock2.default(this.props.auth0Id, this.props.auth0Domain, (0, _extends3.default)({
        auth: {
          redirectUrl: origin + this.props.login,
          responseType: 'token'
        },
        theme: {
          primaryColor: '#FF6300'
        }
      }, this.props.options));

      this.props.authenticated && this.lock.on('authenticated', this.props.authenticated);
      this.props.error && this.lock.on('unrecoverable_error', this.props.error);

      _index2.default.onRouteChangeStart = function () {
        _this2.lock && _this2.lock.hide();
      };

      this.props.ready && this.props.ready(this.lock);
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      this.lock && this.lock.hide();
    }
  }, {
    key: 'render',
    value: function render() {
      // Extract props we don't want to passthrough
      var _props = this.props,
          ready = _props.ready,
          options = _props.options,
          login = _props.login,
          redirect = _props.redirect,
          auth0Id = _props.auth0Id,
          auth0Domain = _props.auth0Domain,
          passThroughProps = (0, _objectWithoutProperties3.default)(_props, ['ready', 'options', 'login', 'redirect', 'auth0Id', 'auth0Domain']);

      var children = this.props.children;

      if (typeof children === 'function') {
        // Custom children
        return children({
          lock: this.lock // Note that this may not be available!
        });
      } else {
        // Create a link with fallback
        return _react2.default.createElement('a', (0, _extends3.default)({}, passThroughProps, { href: login + '?redirect=' + redirect, onClick: this.onClick }));
      }
    }
  }]);

  return Lock;
}(_react2.default.Component);

Lock.defaultProps = {
  login: '/login',
  redirect: '/',
  options: {}
};

exports.default = Lock;