'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _head = require('next/dist/lib/head.js');

var _head2 = _interopRequireDefault(_head);

var _index = require('next/dist/lib/router/index.js');

var _index2 = _interopRequireDefault(_index);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _defaultsDeep = require('lodash/defaultsDeep');

var _defaultsDeep2 = _interopRequireDefault(_defaultsDeep);

var _Lock = require('./Lock');

var _Lock2 = _interopRequireDefault(_Lock);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function Layout(_ref) {
  var children = _ref.children;

  return _react2.default.createElement('div', null, _react2.default.createElement(_head2.default, null, _react2.default.createElement('meta', { name: 'viewport', content: 'width=device-width, initial-scale=1, shrink-to-fit=no' }), _react2.default.createElement('meta', { httpEquiv: 'X-UA-Compatible', content: 'IE=edge' }), _react2.default.createElement('title', null, 'Login'), _react2.default.createElement('style', { dangerouslySetInnerHTML: { __html: 'html{background:#111118;} body{margin:0;padding:0;} body, input, select, option, textarea {font-family: sans-serif;}' } }), _react2.default.createElement('noscript', null, _react2.default.createElement('style', { type: 'text/css' }, '.js{display:none!important;}')), _react2.default.createElement('script', { src: 'https://cdn.polyfill.io/v2/polyfill.min.js' })), children);
}

function Form(props) {

  var defaultOptions = {
    languageDictionary: {
      title: 'Site Name'
    },
    theme: {
      primaryColor: '#FF6300',
      logo: '//cdn.auth0.com/styleguide/1.0.0/img/badge.png'
    }
  };

  var options = (0, _defaultsDeep2.default)(props.options, defaultOptions);

  // Reuse the auth0 css to build a form to create a user
  return _react2.default.createElement('div', { className: 'auth0-lock auth0-lock-opened' }, _react2.default.createElement(_head2.default, null, _react2.default.createElement('title', null, options.languageDictionary.title)), _react2.default.createElement('div', { className: 'auth0-lock-overlay' }), _react2.default.createElement('div', { className: 'auth0-lock-center' }, _react2.default.createElement('form', { className: 'auth0-lock-widget' }, _react2.default.createElement('div', { className: 'auth0-lock-widget-container' }, _react2.default.createElement('div', { className: 'auth0-lock-cred-pane auth0-lock-quiet' }, _react2.default.createElement('div', { className: 'auth0-lock-header' }, _react2.default.createElement('div', { className: 'auth0-lock-header-bg auth0-lock-blur-support' }, _react2.default.createElement('div', { className: 'auth0-lock-header-bg-blur', style: { backgroundImage: 'url(\'' + options.theme.logo + '\')' } }), _react2.default.createElement('div', { className: 'auth0-lock-header-bg-solid', style: { backgroundColor: options.theme.primaryColor } })), _react2.default.createElement('div', { className: 'auth0-lock-header-welcome' }, _react2.default.createElement('img', { className: 'auth0-lock-header-logo', src: options.theme.logo }), _react2.default.createElement('div', { className: 'auth0-lock-name' }, options.languageDictionary.title))), _react2.default.createElement('div', { className: 'auth0-lock-view-content' }, _react2.default.createElement('div', { className: 'auth0-lock-body-content' }, _react2.default.createElement('div', { className: 'auth0-lock-content' }, _react2.default.createElement('div', { className: 'auth0-lock-form' }, _react2.default.createElement('p', null, _react2.default.createElement('span', null, 'Hello, it looks like you are new here...')), _react2.default.createElement('p', { className: 'auth0-lock-alternative' }, _react2.default.createElement('a', { href: '/login?action=check', className: 'auth0-lock-alternative-link' }, 'Already have a profile?')))))), _react2.default.createElement('button', { className: 'auth0-lock-submit', type: 'button', style: { backgroundColor: options.theme.primaryColor } }, _react2.default.createElement('span', { className: 'auth0-label-submit' }, 'Create Profile', _react2.default.createElement('span', null, _react2.default.createElement('svg', { focusable: 'false', className: 'icon-text', width: '8px', height: '12px', viewBox: '0 0 8 12', version: '1.1', xmlns: 'http://www.w3.org/2000/svg' }, _react2.default.createElement('g', { id: 'Symbols', stroke: 'none', strokeWidth: '1', fill: 'none', fillRule: 'evenodd' }, _react2.default.createElement('g', { id: 'Web/Submit/Active', transform: 'translate(-148.000000, -32.000000)', fill: '#FFFFFF' }, _react2.default.createElement('polygon', { id: 'Shape', points: '148 33.4 149.4 32 155.4 38 149.4 44 148 42.6 152.6 38' }))))))))))));
}

// <form className="auth0-lock-widget">
//   <div className="auth0-lock-cred-pane">
//     <div className="auth0-lock-content">
//       <div><p><span>Hello, it looks like you are new here...</span></p></div>
//       <input type="email" name="email" placeholder="Contact Email" />
//       <input type="text" name="name" placeholder="Display Name" />
//       <input type="text" name="username" placeholder="Username" />
//     </div>
//     <button className="auth0-lock-submit" type="button">Create Account</button>
//   </div>
// </form>

// The login page will either show a login form or handle the login and user creation process when returning from auth

var Login = function (_React$Component) {
  (0, _inherits3.default)(Login, _React$Component);

  function Login(props) {
    (0, _classCallCheck3.default)(this, Login);

    var _this = (0, _possibleConstructorReturn3.default)(this, (Login.__proto__ || (0, _getPrototypeOf2.default)(Login)).call(this, props));

    _this.lockReady = function (lock) {
      _this.setState({ lock: lock });
    };

    _this.onAuthenticated = function (authResult) {

      _this.state.lock && _this.state.lock.getUserInfo(authResult.accessToken, function (error, profile) {
        //console.log('authenticated',authResult, profile, error);

        if (error) {
          _this.state.lock && _this.state.lock.show({
            flashMessage: {
              type: 'error',
              text: 'Invalid Token'
            }
          });
        } else {
          // Can we do verify here whilst we still have data?
          if (_this.props.verify) {
            _this.props.verify(function (user) {
              // If verify returns then set default user state for form
              _this.setState({ user: user });
              //Router.replace(this.props.login + '?action=create');  
            }, authResult, profile);
          } else {
            // Just redirect
            _index2.default.replace('/');
          }

          // try{
          //   window.localStorage.setItem("auth0AccessToken", authResult.accessToken);          
          //   window.localStorage.setItem('auth0IdToken', authResult.idToken);
          //   window.localStorage.setItem("auth0Profile", JSON.stringify(profile));

          //   // Redirect to verify or create user
          //   Router.replace(this.props.login + '?action=verify');

          // }
          // catch(e){
          //   this.state.lock && this.state.lock.show({
          //     flashMessage: {
          //       type: 'error',
          //       text: 'You must allow your browser to use local storage to login.'
          //     }
          //   });      
          // }
        }
      });
    };

    _this.onError = function (error) {
      //console.log('auth error', error);

      _this.state.lock && _this.state.lock.show({
        flashMessage: {
          type: 'error',
          text: 'There was an error, please try again.'
        }
      });
    };

    _this.layout = function () {
      var _this$props = _this.props,
          url = _this$props.url,
          options = _this$props.options;
      var _this$state = _this.state,
          lock = _this$state.lock,
          user = _this$state.user;

      var action = url && url.query && url.query.action;

      if (lock) {
        if (user) {
          return _react2.default.createElement(Form, { options: options });
        } else {
          return _react2.default.createElement(_head2.default, null, _react2.default.createElement('title', null, 'Login'));
        }
      } else {
        return _react2.default.createElement(_head2.default, null, _react2.default.createElement('title', null, 'Initialising...'));
      }
    };

    _this.state = {
      lock: null, // we have to wait for the lock to be initialised
      user: null // create user data
    };
    return _this;
  }

  (0, _createClass3.default)(Login, [{
    key: 'componentDidUpdate',
    value: function componentDidUpdate(prevProps, prevState) {

      // We should always get a componentDidUpdate as the lock will trigger a state change when its ready.
      var url = this.props.url;

      var action = url && url.query && url.query.action;

      // If we are not doing verify or create and we have a new lock then open it for login
      // Note that the return from auth0 with #hash will hit this also. Lock will authenticate and redirect to verify action
      if (!this.state.user && !window.location.hash && this.state.lock && !prevState.lock) {
        if (action === 'check') {
          // Let the user check they used the correct account (they might have use social before etc.)
          this.state.lock.show({
            flashMessage: {
              type: 'error',
              text: 'Check the account credentials that you created your profile with are correct'
            }
          });
        } else {
          this.state.lock.show();
        }
      } else {
        // we have some user data to create a new user
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          auth0Id = _props.auth0Id,
          auth0Domain = _props.auth0Domain,
          options = _props.options;

      var defaultOptions = {
        languageDictionary: {
          title: 'Site Name'
        },
        theme: {
          primaryColor: '#FF6300',
          logo: '//cdn.auth0.com/styleguide/1.0.0/img/badge.png'
        }
      };
      return _react2.default.createElement(_Lock2.default, { error: this.onError, authenticated: this.onAuthenticated, options: (0, _extends3.default)({}, (0, _defaultsDeep2.default)(options, defaultOptions), { closable: false, autoclose: false }), ready: this.lockReady, children: function children(props) {
          return _react2.default.createElement(Layout, null, _this2.layout(props));
        }, auth0Id: auth0Id, auth0Domain: auth0Domain });
    }
  }]);

  return Login;
}(_react2.default.Component);

Login.defaultProps = {
  login: '/login',
  options: {}
};

exports.default = Login;